package com.huimv.farm.damsubsidy.controller;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BillLandingInspection;
import com.huimv.farm.damsubsidy.entity.BillSubsidy;
import com.huimv.farm.damsubsidy.entity.SysUser;
import com.huimv.farm.damsubsidy.mapper.SysUserMapper;
import com.huimv.farm.damsubsidy.service.IBillLandingInspectionService;
import com.huimv.farm.damsubsidy.service.IBillSubsidyService;
import com.huimv.farm.damsubsidy.service.ISysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 企业合作社 前端控制器
 * </p>
 *
 * @author Newspaper
 * @since 2023-04-27
 */
@CrossOrigin
@RestController
@RequestMapping("/Enterprise-Cooperative")
public class EnterpriseCooperativeController {
    @Autowired
    private IBillSubsidyService iBillSubsidyService;

    @Autowired
    private IBillLandingInspectionService iBillLandingInspectionService;


    @PostMapping("/listApplication")
    public Result listApplication(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap){
        String startTime = paramsMap.get("startTime");
        String endTime = paramsMap.get("endTime");
        String applicationType = paramsMap.get("applicationType");
        String applicationStatus = paramsMap.get("applicationStatus");
        QueryWrapper<BillSubsidy> subsidyQueryWrapper = new QueryWrapper<>();
        QueryWrapper<BillLandingInspection> landingInspectionQueryWrapper = new QueryWrapper<>();
        if (startTime != null) {
            startTime = startTime + " 00:00:00";
            subsidyQueryWrapper.ge("create_time",startTime);
            landingInspectionQueryWrapper.ge("create_time",startTime);
        }
        if (endTime != null) {
            endTime = endTime + " 23:59:59";
            subsidyQueryWrapper.le("create_time",endTime);
            landingInspectionQueryWrapper.le("create_time",endTime);
        }


        subsidyQueryWrapper.eq("creat_user",TokenSign.getUserName(httpServletRequest))
                .orderByDesc("create_time");
        landingInspectionQueryWrapper.eq("creat_user",TokenSign.getUserName(httpServletRequest))
                .orderByDesc("create_time");

        Map<String,Object> resultMap = new HashMap<String,Object>();
        if (ObjectUtil.isNotEmpty(applicationStatus)){
            landingInspectionQueryWrapper.eq("inspection_sch",applicationStatus);
            subsidyQueryWrapper.eq("subsidy_sch",applicationStatus);
        }
        if (ObjectUtil.isNotEmpty(applicationStatus)){
            landingInspectionQueryWrapper.eq("inspection_sch",applicationStatus);
            subsidyQueryWrapper.eq("subsidy_sch",applicationStatus);
        }
        if ("0".equals(applicationType)){
            List<BillSubsidy> subsidyList = iBillSubsidyService.list(subsidyQueryWrapper);
            List<BillLandingInspection> landingInspectionList = iBillLandingInspectionService.list(landingInspectionQueryWrapper);
            resultMap.put("subsidyList",subsidyList);
            resultMap.put("LandingInspectionList",landingInspectionList);
        }else if ("1".equals(applicationType)){
            List<BillLandingInspection> subsidyList = iBillLandingInspectionService.list(landingInspectionQueryWrapper);
            resultMap.put("subsidyList",subsidyList);
        }else {
            List<BillLandingInspection> landingInspectionList = iBillLandingInspectionService.list(landingInspectionQueryWrapper);
            resultMap.put("LandingInspectionList",landingInspectionList);
        }
        return new Result(ResultCode.SUCCESS,resultMap);
    }


}
