package com.huimv.farm.damsubsidy.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.BankUtil;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.entity.*;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.mapper.BaseAnimalMapper;
import com.huimv.farm.damsubsidy.mapper.BillSubsidyMapper;
import com.huimv.farm.damsubsidy.mapper.SysUserMapper;
import com.huimv.farm.damsubsidy.service.IBillSubsidyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 补贴信息表 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Service
public class BillSubsidyServiceImpl extends ServiceImpl<BillSubsidyMapper, BillSubsidy> implements IBillSubsidyService {

    @Autowired
    private BillSubsidyMapper subsidyMapper;
    @Autowired
    private SysUserMapper sysUserMapper;

    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String type = paramsMap.get("subsidySch");
        String pageSize = paramsMap.get("pageSize");
        String pageNum = paramsMap.get("pageNum");
        if (pageSize == null || pageSize == "") {
            pageSize = "10";
        }
        if (pageNum == null || pageNum == "") {
            pageNum = "1";
        }

        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        if (type == null || type == "") {
            queryWrapper.orderByDesc("sub_time");
        } else if (Integer.parseInt(type) == 1) {
            queryWrapper.eq("subsidy_sch", 0).orderByDesc("sub_time");
        } else if (Integer.parseInt(type) == 2) {
            queryWrapper.eq("subsidy_sch", 1).orderByDesc("sub_time");
        } else {
            queryWrapper.ge("subsidy_sch", 2).orderByDesc("sub_time");
        }
        Page<BillSubsidy> page = new Page(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
//        List<BillSubsidy> billSubsidies = subsidyMapper.selectList(queryWrapper);

//        JSONArray jsonArray = new JSONArray();
//        for (BillSubsidy billSubsidy : billSubsidies) {
//            JSONObject jsonObject = new JSONObject();
//            jsonObject.put("name", billSubsidy.getSubsidyName());
//            jsonObject.put("date", billSubsidy.getSubTime());
//            jsonObject.put("state", billSubsidy.getSubsidySch());
//            jsonObject.put("id", billSubsidy.getId());
//            jsonArray.add(jsonObject);
//        }
        return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
    }

    @Override
    public Result listById(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", paramsMap.get("id"));
        BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
        return new Result(ResultCode.SUCCESS, billSubsidy);
    }

    @Override
    public Result edit(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        Integer type = Integer.parseInt(paramsMap.get("type"));
        String id = paramsMap.get("id");
        //拒绝
        if (type == 1) {
            String refuseReason = paramsMap.get("refuseReason"); //拒绝理由
            if (refuseReason == "" || refuseReason == null) {
                return new Result(ResultCode.FAIL, "拒绝理由不能为空！");
            }
            QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id", id);
            BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
            billSubsidy.setRefuseReason(refuseReason);
            billSubsidy.setSubsidySch(2);
            billSubsidy.setAcceptTime(new Date());
            subsidyMapper.updateById(billSubsidy);
            return new Result(ResultCode.SUCCESS, billSubsidy);
        } else { //受理
            QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id", id);
            BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
            billSubsidy.setSubsidySch(1);
            billSubsidy.setAcceptTime(new Date());
            subsidyMapper.updateById(billSubsidy);
            return new Result(ResultCode.SUCCESS, billSubsidy);
        }
    }

    @Override
    public Result edit2(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        Integer type = Integer.parseInt(paramsMap.get("type"));
        String id = paramsMap.get("id");

        String workAccptUrl = paramsMap.get("workAccptUrl");
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", id);
        BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
        if (type == 1) { //驳回
            String rejectReason = paramsMap.get("rejectReason");
            if (rejectReason == null || rejectReason == "") {
                return new Result(ResultCode.FAIL, "驳回理由不能为空！");
            }
            if (workAccptUrl == null || workAccptUrl == "") {
                return new Result(ResultCode.FAIL, "工作验收表不能为空！");
            }
            billSubsidy.setSubsidySch(4);
            billSubsidy.setRejectReason(rejectReason);
            billSubsidy.setWorkAccptUrl(workAccptUrl);
            billSubsidy.setAcceptTime(new Date());
            subsidyMapper.updateById(billSubsidy);
            return new Result(ResultCode.SUCCESS, billSubsidy);
        } else { //通过
            billSubsidy.setSubsidySch(3);
            billSubsidy.setAcceptTime(new Date());
            if (workAccptUrl == null || workAccptUrl == "") {
                billSubsidy.setIsPay(0);
            } else {
                billSubsidy.setWorkAccptUrl(workAccptUrl);
                billSubsidy.setIsPay(1);
            }
            billSubsidy.setReviewedTime(new Date());
            subsidyMapper.updateById(billSubsidy);
            return new Result(ResultCode.SUCCESS, billSubsidy);
        }
    }

    @Override
    public Result appeal(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        Integer type = Integer.parseInt(paramsMap.get("type"));
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", id);
        BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
        if (type == 1) { //驳回
            billSubsidy.setSubsidySch(4);
            billSubsidy.setAppealTime(new Date());
            subsidyMapper.updateById(billSubsidy);
        } else {
            billSubsidy.setSubsidySch(3);
            billSubsidy.setAppealTime(new Date());
            subsidyMapper.updateById(billSubsidy);
        }
        return new Result(ResultCode.SUCCESS, billSubsidy);
    }

    @Resource
    private BaseAnimalMapper baseAnimalMapper;

    @Override
    @Transactional
    public Result addApplication(HttpServletRequest httpServletRequest, BillSubsidy billSubsidy) {
        String eartagNo = billSubsidy.getEartagNo();
        String[] eartags = eartagNo.split(",");
        String bankCardId = billSubsidy.getBankCardId();
        if(!(BankUtil.checkBankCard(bankCardId))){
            return new Result(10001,"银行卡号不符合标准!",false);
        }
        for (String eartag : eartags) {
            if (!eartag.contains("-")){
                BaseAnimal animal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", eartag));
                animal.setIsLoated(1);
                baseAnimalMapper.updateById(animal);
            }else {
                String start = eartag.substring(0, eartag.indexOf("-"));
                String end = eartag.substring(eartag.indexOf("-") + 1);
                String substring = start.substring(0, start.length() - end.length());
                String finish = substring+end;
                List<Integer> numbers = new ArrayList<>();
                for (int i = Integer.parseInt(start); i <= Integer.parseInt(finish); i++) {
                    numbers.add(i);
                }
                for (Integer number : numbers) {
                    String earatgNo = number.toString();
                    BaseAnimal animal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", earatgNo));
                    animal.setIsLoated(1);
                    baseAnimalMapper.updateById(animal);
                }
            }
        }
        billSubsidy.setBankName(BankUtil.getname(bankCardId));
        billSubsidy.setSubsidyName(billSubsidy.getFarmerName()+"的补贴申请");
        billSubsidy.setCreateTime(DateTime.now());
        billSubsidy.setCreateUser(TokenSign.getUserName(httpServletRequest));
        billSubsidy.setSubsidySch(0);
        String userName = TokenSign.getUserName(httpServletRequest);
        BillSubsidy subsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("create_user", userName).eq("subsidy_sch", 7));
        if (ObjectUtil.isEmpty(subsidy)){
            this.save(billSubsidy);
        }else {
            this.update(billSubsidy,new QueryWrapper<BillSubsidy>().eq("create_user",userName).eq("subsidy_sch",7));
        }
        return Result.SUCCESS();
    }

    @Override
    public Result saveApplication(HttpServletRequest httpServletRequest, BillSubsidy billSubsidy) {
        String userName = TokenSign.getUserName(httpServletRequest);
        BillSubsidy subsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("create_user", userName).eq("subsidy_sch", 7));
        billSubsidy.setSubsidySch(7);
        billSubsidy.setCreateUser(userName);
        if (ObjectUtil.isEmpty(subsidy)){
            this.save(billSubsidy);
        }else {
            this.update(billSubsidy,new QueryWrapper<BillSubsidy>().eq("create_user",userName).eq("subsidy_sch",7));
        }
        return Result.SUCCESS();
    }

    @Override
    public Result listPcSub(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String userName = paramsMap.get("userName");
        String date = paramsMap.get("date");
        String pageSize = paramsMap.get("pageSize");
        String pageNum = paramsMap.get("pageNum");
        String type = paramsMap.get("type");
        if (pageSize == null || pageSize == "") {
            pageSize = "10";
        }
        if (pageNum == null || pageNum == "") {
            pageNum = "1";
        }
        if (date != "") {
            date = date + " 00:00:00";
        }


        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.ge(StringUtils.isNotBlank(date),"sub_time", date)
                .like(StringUtils.isNotBlank(userName),"farmer_name", userName);

        if (Integer.parseInt(type) == 7) {
            queryWrapper.eq("is_pay", 1);
            Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
            return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
        }
        if (Integer.parseInt(type) == 6) {
            queryWrapper.eq("is_pay", 2);
            Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
            return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
        }
        queryWrapper.eq(StringUtils.isNotBlank(type),"subsidy_sch",type);
        Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
        return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
    }

    @Override
    public Result editApplication(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        String type = paramsMap.get("type");
        BillSubsidy billSubsidy = this.getById(id);
        //养殖户撤销补贴申请
//        if ("1".equals(type)){
//            billSubsidy.setSubsidySch(8);
//            billSubsidy.setRevokeTime(LocalDate.now());
//            this.updateById(billSubsidy);
//            List<BaseAnimal> baseAnimals = baseAnimalMapper.selectList(new QueryWrapper<BaseAnimal>().eq("inspection_num", billSubsidy.getInspectionNum()));
//            for (BaseAnimal baseAnimal : baseAnimals) {
//                baseAnimal.setIsLoated(0);
//                baseAnimalMapper.updateById(baseAnimal);
//            }
//            return Result.SUCCESS();
//        }
        if ("1".equals(type)) {
            List<BaseAnimal> baseAnimals = baseAnimalMapper.selectList(new QueryWrapper<BaseAnimal>().eq("inspection_num", billSubsidy.getInspectionNum()));
            for (BaseAnimal baseAnimal : baseAnimals) {
                baseAnimal.setIsLoated(0);
                baseAnimalMapper.updateById(baseAnimal);
            }
            this.removeById(billSubsidy);
            return Result.SUCCESS();
        } else {
//          养殖户申诉不通过补贴申请
            String appeal = paramsMap.get("appeal");
            billSubsidy.setAppeal(appeal);
            billSubsidy.setSubsidySch(5);
            billSubsidy.setAppealTime(new Date());
            if (this.updateById(billSubsidy)) {
                return Result.SUCCESS();
            } else {
                return Result.ERROR();
            }
        }
    }

    @Override
    public Result listApplication(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String subsidySch = paramsMap.get("subsidySch");
//        String startTime = paramsMap.get("startTime");
//        String endTime = paramsMap.get("endTime");
        String userName = TokenSign.getUserName(httpServletRequest);
        Integer userType = sysUserMapper.selectOne(new QueryWrapper<SysUser>().eq("user_name", userName)).getUserType();

        QueryWrapper<BillSubsidy> subsidyQueryWrapper = new QueryWrapper<>();

        if (userType == 2 || userType == 3) {
            subsidyQueryWrapper.eq("create_user", userName);
            if (ObjectUtil.isNotEmpty(subsidySch)){
                if (subsidySch.equals("1")){
                    subsidyQueryWrapper.eq("subsidy_sch",0);
                }else if (subsidySch.equals("2")){
                    subsidyQueryWrapper.in("subsidy_sch",1,5);
                }else if (subsidySch.equals("3")){
                    subsidyQueryWrapper.in("subsidy_sch",2,3,4);
                }else if (subsidySch.equals("4")){
                    subsidyQueryWrapper.eq("is_pay",2);
                }
            }else {
                subsidyQueryWrapper.ne("subsidy_sch",7);
            }
        }else {
            if (ObjectUtil.isNotEmpty(subsidySch)){
                if (subsidySch.equals("1")){
                    subsidyQueryWrapper.eq("subsidy_sch",0);
                }else if (subsidySch.equals("2")){
                    subsidyQueryWrapper.in("subsidy_sch",1,5);
                }else if (subsidySch.equals("3")){
                    subsidyQueryWrapper.in("subsidy_sch",2,3,4);
                }else if (subsidySch.equals("4")){
                    subsidyQueryWrapper.eq("is_pay",2);
                }
            }else {
                subsidyQueryWrapper.ne("subsidy_sch",7);
            }
        }
//        if (startTime != null) {
//            startTime = startTime + " 00:00:00";
//            subsidyQueryWrapper.ge("create_time",startTime);
//        }
//        if (endTime != null) {
//            endTime = endTime + " 23:59:59";
//            subsidyQueryWrapper.le("create_time",endTime);
//        }

        subsidyQueryWrapper.orderByDesc("create_time");
        Page<BillSubsidy> page = new Page(Integer.parseInt(pageNum),Integer.parseInt(pageSize));
        return new Result(ResultCode.SUCCESS,subsidyMapper.selectPage(page,subsidyQueryWrapper));
    }

    @Override
    public Result getLast(HttpServletRequest httpServletRequest, Map<String, String> parasMap) {
        BillSubsidy billSubsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("creat_user", TokenSign.getUserName(httpServletRequest)).eq("subsidy_sch", 7));
        if (ObjectUtil.isEmpty(billSubsidy)){
            return new Result(ResultCode.SUCCESS,null);
        }else {
            return new Result(ResultCode.SUCCESS,billSubsidy);
        }
    }

    @Override
    public Result listFlow(Map<String, String> parasMap) {
        String id = parasMap.get("id");
        BillSubsidy billSubsidy = this.getById(id);
        List result = new ArrayList();
        if (billSubsidy.getSubsidySch() == 0){
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setStatus(true);
            addApplication.setReason("");
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            BaseApplication lastApplication = new BaseApplication();
            lastApplication.setTitle("待受理");
            result.add(lastApplication);
        }else if (billSubsidy.getSubsidySch() == 1){
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setStatus(true);
            addApplication.setReason("");
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication receiveApplication = new RejectApplication();
            receiveApplication.setTitle("已受理");
            receiveApplication.setStatus(true);
            receiveApplication.setReason("");
            receiveApplication.setTime(billSubsidy.getAcceptTime());
            result.add(receiveApplication);

            BaseApplication lastApplication = new BaseApplication();
            lastApplication.setTitle("审核中");
            result.add(lastApplication);
        }else if (billSubsidy.getSubsidySch() == 2){
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setReason("");
            addApplication.setStatus(true);
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication rejectApplication = new RejectApplication();
            rejectApplication.setTitle("已拒绝");
            rejectApplication.setStatus(false);
            rejectApplication.setTime(billSubsidy.getAcceptTime());
            rejectApplication.setReason("拒绝理由:"+billSubsidy.getRefuseReason());
            result.add(rejectApplication);
        }else if (billSubsidy.getSubsidySch() == 3){
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setReason("");
            addApplication.setStatus(true);
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication receiveApplication = new RejectApplication();
            receiveApplication.setTitle("已受理");
            receiveApplication.setReason("");
            receiveApplication.setStatus(true);
            receiveApplication.setTime(billSubsidy.getAcceptTime());
            result.add(receiveApplication);

            RejectApplication acceptApplication = new RejectApplication();
            acceptApplication.setTitle("审核通过");
            acceptApplication.setReason("");
            acceptApplication.setStatus(true);
            acceptApplication.setTime(billSubsidy.getAcceptTime());
            result.add(acceptApplication);

            if (billSubsidy.getIsPay() == 2){
                RejectApplication payApplication = new RejectApplication();
                payApplication.setTitle("已支付");
                payApplication.setStatus(true);
                payApplication.setTime(billSubsidy.getPayTime());
                if (ObjectUtil.isEmpty(billSubsidy.getPayMoney())){
                    payApplication.setReason("支付金额: ¥"+"");
                }else {
                    payApplication.setReason("支付金额: ¥"+billSubsidy.getPayMoney().toString());
                }
                result.add(payApplication);
            }else {
                RejectApplication lastApplication = new RejectApplication();
                lastApplication.setTitle("待支付");
                result.add(lastApplication);
            }
        }else if (billSubsidy.getSubsidySch() == 4){
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setReason("");
            addApplication.setStatus(true);
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication receiveApplication = new RejectApplication();
            receiveApplication.setTitle("已受理");
            receiveApplication.setReason("");
            receiveApplication.setStatus(true);
            receiveApplication.setTime(billSubsidy.getAcceptTime());
            result.add(receiveApplication);

            RejectApplication rejectApplication = new RejectApplication();
            rejectApplication.setTitle("审核不通过");
            rejectApplication.setStatus(false);
            rejectApplication.setTime(billSubsidy.getReviewedTime());
            rejectApplication.setReason("驳回理由: "+billSubsidy.getRejectReason());
            result.add(rejectApplication);
        }else if (billSubsidy.getSubsidySch() == 5){
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setReason("");
            addApplication.setStatus(true);
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication receiveApplication = new RejectApplication();
            receiveApplication.setReason("");
            receiveApplication.setTitle("已受理");
            receiveApplication.setStatus(true);
            receiveApplication.setTime(billSubsidy.getAcceptTime());
            result.add(receiveApplication);

            RejectApplication rejectApplication = new RejectApplication();
            rejectApplication.setTitle("审核不通过");
            rejectApplication.setStatus(false);
            rejectApplication.setTime(billSubsidy.getReviewedTime());
            rejectApplication.setReason("驳回理由: "+billSubsidy.getRejectReason());
            result.add(rejectApplication);

            RejectApplication appealApplication = new RejectApplication();
            appealApplication.setTitle("已申诉");
            appealApplication.setStatus(true);
            appealApplication.setTime(billSubsidy.getAppealTime());
            appealApplication.setReason("申诉内容描述: "+billSubsidy.getAppeal());
            result.add(appealApplication);

            BaseApplication lastApplication = new BaseApplication();
            lastApplication.setTitle("待受理");
            result.add(lastApplication);
        }
        return new Result(ResultCode.SUCCESS,result);
    }
}
